/*
 * Copyright (c) 2005 Your Corporation. All Rights Reserved.
 */
package org.activemq.transport.stomp;

import java.io.DataInput;
import java.io.IOException;
import java.util.Properties;

interface Command
{
    public PacketEnvelope build(String commandLine, DataInput in) throws IOException;

    /**
     * Returns a command instance which always returns null for a packet 
     */
    Command NULL_COMMAND = new Command()
    {
        public PacketEnvelope build(String commandLine, DataInput in)
        {
            return new PacketEnvelope(null, new Properties());
        }
    };
}
