/**
 * Marshalling code for Open Wire Format for ConnectionInfo
 *
 *
 * NOTE!: This file is autogenerated - do not modify!
 *        if you need to make a change, please see the Groovy scripts in the
 *        activemq-openwire module
 */

package org.activemq.transport.openwire.io;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.activemq.message.*;
import org.activemq.io.*;
import org.activemq.io.impl.*;
import org.activemq.transport.openwire.OpenWirePacketMarshallerSupport;

/**
 * AUTOGENERATED Marshaller for OpenWire command ConnectionInfo
 *
 * @version $Revision: 1.1 $
 */
public class ConnectionInfoMarshaller extends OpenWirePacketMarshallerSupport {

    /**
     * Return the type of Packet
     *
     * @return integer representation of the type of Packet
     */
    public int getPacketType() {
        return 22;
    }

    /**
     * @return a new Packet instance
     */
    public Packet createPacket() {
        return new ConnectionInfo();
    }

    /**
     * build a Packet instance from the data input stream
     *
     * @param packet A Packet object
     * @param dataIn the data input stream to build the packet from
     * @throws IOException
     */
    public void buildPacket(Packet packet, DataInput dataIn) throws IOException {
        super.buildPacket(packet, dataIn);
        ConnectionInfo info = (ConnectionInfo) packet;
        info.setClientId(readString(dataIn));
        info.setHostName(readString(dataIn));
        info.setPassword(readString(dataIn));
        info.setProperties(readProperties(dataIn));
        info.setStartTime(dataIn.readLong());
        info.setUserName(readString(dataIn));
        info.setStarted(dataIn.readBoolean());
        info.setClosed(dataIn.readBoolean());
        info.setClientVersion(readString(dataIn));
        info.setWireFormatVersion(dataIn.readInt());

    }

    /**
     * Write a Packet instance to data output stream
     *
     * @param packet  the instance to be seralized
     * @param dataOut the output stream
     * @throws IOException thrown if an error occurs
     */
    public void writePacket(Packet packet, DataOutput dataOut) throws IOException {
        super.writePacket(packet, dataOut);
        ConnectionInfo info = (ConnectionInfo) packet;
        writeString(info.getClientId(), dataOut);
        writeString(info.getHostName(), dataOut);
        writeString(info.getPassword(), dataOut);
        writeProperties(info.getProperties(), dataOut);
        dataOut.writeLong(info.getStartTime());
        writeString(info.getUserName(), dataOut);
        dataOut.writeBoolean(info.isStarted());
        dataOut.writeBoolean(info.isClosed());
        writeString(info.getClientVersion(), dataOut);
        dataOut.writeInt(info.getWireFormatVersion());

    }
}
