/**
 * Marshalling code for Open Wire Format for MessageAck
 *
 *
 * NOTE!: This file is autogenerated - do not modify!
 *        if you need to make a change, please see the Groovy scripts in the
 *        activemq-openwire module
 */

package org.activemq.transport.openwire.io;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.activemq.message.*;
import org.activemq.io.*;
import org.activemq.io.impl.*;
import org.activemq.transport.openwire.OpenWirePacketMarshallerSupport;

/**
 * AUTOGENERATED Marshaller for OpenWire command MessageAck
 *
 * @version $Revision: 1.1 $
 */
public class MessageAckMarshaller extends OpenWirePacketMarshallerSupport {

    /**
     * Return the type of Packet
     *
     * @return integer representation of the type of Packet
     */
    public int getPacketType() {
        return 5;
    }

    /**
     * @return a new Packet instance
     */
    public Packet createPacket() {
        return new MessageAck();
    }

    /**
     * build a Packet instance from the data input stream
     *
     * @param packet A Packet object
     * @param dataIn the data input stream to build the packet from
     * @throws IOException
     */
    public void buildPacket(Packet packet, DataInput dataIn) throws IOException {
        super.buildPacket(packet, dataIn);
        MessageAck info = (MessageAck) packet;
        info.setMessageID(readString(dataIn));
        info.setMessageRead(dataIn.readBoolean());
        info.setConsumerId(readString(dataIn));
        info.setDestination(readDestination(dataIn));
        info.setPersistent(dataIn.readBoolean());
        info.setExpired(dataIn.readBoolean());
        info.setProducerKey(readString(dataIn));
        info.setSequenceNumber(dataIn.readLong());
        info.setSessionId(dataIn.readShort());
        info.setExternalMessageId(dataIn.readBoolean());
        info.setTransactionIDString(readString(dataIn));

    }

    /**
     * Write a Packet instance to data output stream
     *
     * @param packet  the instance to be seralized
     * @param dataOut the output stream
     * @throws IOException thrown if an error occurs
     */
    public void writePacket(Packet packet, DataOutput dataOut) throws IOException {
        super.writePacket(packet, dataOut);
        MessageAck info = (MessageAck) packet;
        writeString(info.getMessageID(), dataOut);
        dataOut.writeBoolean(info.isMessageRead());
        writeString(info.getConsumerId(), dataOut);
        writeDestination(info.getDestination(), dataOut);
        dataOut.writeBoolean(info.isPersistent());
        dataOut.writeBoolean(info.isExpired());
        writeString(info.getProducerKey(), dataOut);
        dataOut.writeLong(info.getSequenceNumber());
        dataOut.writeShort(info.getSessionId());
        dataOut.writeBoolean(info.isExternalMessageId());
        writeString(info.getTransactionIDString(), dataOut);

    }
}
